//
//  cspl.h
//  SPNP
//
//  Created by Stephen Gilmore on 12/08/2013.
//
//

#ifndef SPNP_cspl_h
#define SPNP_cspl_h

//int hash_look(symb)
int	hash_look(char);

// int insert_symb(name,type,numb)
int	insert_symb(char*,int,int);

//int search_symb(name)
int	search_symb(char*);

//void iopt(opt,val)
void iopt(int,int);

//void fopt(opt,val)
void fopt(int,double);

//void Cplace(name,n1,n2)
void Cplace(char[],int,int);

//int findplace(name,n1,n2)
int	findplace(char[],int,int);

//int findtrans(name,n1,n2)
int	findtrans(char[],int,int);

//void Cinit(name,n1,n2,init)
void Cinit(char[],int,int,int);

//void Ctrans(name,n1,n2)
void Ctrans(char*,int,int);

//void Cpriority(name,n1,n2,prio)
void Cpriority(char*,int,int,int);

//void Cenabling(name,n1,n2,efunc)
void Cenabling(char*,int,int,int(*efunc)());

//void	Cdistr(type,name,n1,n2,dep,val,dval,place,p1,p2,fun,dfun)
void Cdistr(int,char*,int,int,int,double,double,char*,int,int,double (*fun)(), double(*dfun)());

//void Carc(type,tr,t1,t2,pl,p1,p2,mult,func)
void Carc(int,char*,int,int,char*,int,int,int,int (*func)());

int install();

//double input(descr)
double input(char*);

//int Cmark(pl,n1,n2)
int	Cmark(char*,int,int);

//int internal_enabled(tr)
int internal_enabled(TR*);

//double internal_rate(tr)
double internal_rate(TR);

//int Cenabled(tr,n1,n2)
int Cenabled(char*,int,int);

//double Crate(tr,n1,n2)
double Crate(char*,int,int);

//double expected(func)
double expected(void (*func)());

//double der_expected(func,derfunc)
double der_expected(void (*func)(),void (*derfunc)());

//double cum_expected(func)
double cum_expected(void (*func)());

//double der_cum_expected(func,derfunc)
double der_cum_expected(void (*func)(),void (*derfunc)());

//double accumulated(func)
double accumulated(void (*func)());

//void hold_cond(cond,times)
void hold_cond(int (*cond)(),double[]);

void pr_std_average();

void pr_std_average_der();

void pr_std_cum_average();

void pr_std_cum_average_der();

void pr_net_info();

void pr_rg_info();

void pr_mc_info();

//void	pr_expected(string,func)
void pr_expected(char*,double (*func)());

//void	pr_sens_expected(string,func,derfunc)
void pr_sens_expected(char*,double (*func)(),double (*derfunc)());

//void	pr_cum_expected(string,func)
void pr_cum_expected(char*,double (*func)());

//void	pr_time_avg_expected(string,func)
void pr_time_avg_expected(char*,double (*func)());

//void	pr_sens_cum_expected(string,func,derfunc)
void pr_sens_cum_expected(char*,double (*func)(),double (*derfunc)());

//void	pr_accumulated(string,func)
void pr_accumulated(char*,double (*func)());

//void	pr_hold_cond(string,cond)
void pr_hold_cond(char*,int (*cond)());

//void	Cset_prob0(scale,func)
void Cset_prob0(int,double (*func)());

//void print_time( time_value )
void print_time( double );


#endif
