
/*LINTLIBRARY*/

/*************************************************************************
FILE:	user.h
*/

# include	<stdio.h>
# include	"const.h"
# include	"type.h"
# include	"port.h"
# include	"cspl.h"

# define	 enabling_type		int
# define	 probability_type	double
# define	 rate_type		double
# define	 reward_type		double

/*extern	double	input();
extern	void	iopt();
extern	void	fopt();
extern	void	pr_std_average();
extern  void    pr_std_cum_average();
extern	void	pr_net_info();
extern	void	pr_rg_info();
extern	void	pr_mc_info();
extern	void	pr_expected();
extern  void    pr_cum_expected();
extern	void	pr_accumulated();
extern	void	pr_hold_cond();
extern	double	expected();
extern	double	cum_expected();
extern	double	accumulated();
extern	void	hold_cond();
extern	void	Cplace();
extern	void	Cinit();
extern	void	Ctrans();
extern	void	Cpriority();
extern	void	Cenabling();
extern	void	Cdistr();
extern	void	Carc();
extern	int	Cmark();
extern	int	Cenabl();
extern	double	Crate();
extern	void	Cset_prob0();
 */

void	place(char*);
void	place_0(char*);
void	place_1(char*,int);
void	place_2(char*,int,int);
void	init(char*,int);
void	init_0(char*,int);
void	init_1(char*,int,int);
void	init_2(char*,int,int,int);
void	trans(char*);
void	trans_0(char*);
void	trans_1(char*,int);
void	trans_2(char*,int,int);
void	priority(char*,int);
void	priority_0(char*,int);
void	priority_1(char*,int,int);
void	priority_2(char*,int,int,int);
void	enabling(char*,int(*en)());
void	enabling_0(char*,int(*en)());
void	enabling_1(char*,int,int(*en)());
void	enabling_2(char*,int,int,int(*en)());
void	probval(char*,double);
void	probval_0(char*,double);
void	probval_1(char*,int,double);
void	probval_2(char*,int,int,double);
void	rateval(char*,double);
void	rateval_0(char*,double);
void	rateval_1(char*,int,double);
void	rateval_2(char*,int,int,double);
void	probdep(char*,double,char*);
void	probdep_0_0(char*,double,char*);
void	probdep_1_0(char*,int,double,char*);
void	probdep_2_0(char*,int,int,double,char*);
void	probdep_0_1(char*,double,char*,int);
void	probdep_1_1(char*,int,double,char*,int);
void	probdep_2_1(char*,int,int,double,char*,int);
void	probdep_0_2(char*,double,char*,int,int);
void	probdep_1_2(char*,int,double,char*,int,int);
void	probdep_2_2(char*,int,int,double,char*,int,int);
void	ratedep(char*,double,char*);
void	ratedep_0_0(char*,double,char*);
void	ratedep_1_0(char*,int,double,char*);
void	ratedep_2_0(char*,int,int,double,char*);
void	ratedep_0_1(char*,double,char*,int);
void	ratedep_1_1(char*,int,double,char*,int);
void	ratedep_2_1(char*,int,int,double,char*,int);
void	ratedep_0_2(char*,double,char*,int,int);
void	ratedep_1_2(char*,int,double,char*,int,int);
void	ratedep_2_2(char*,int,int,double,char*,int,int);
void	probfun(char*,double (*f)());
void	probfun_0(char*,double (*f)());
void	probfun_1(char*,int,double (*f)());
void	probfun_2(char*,int,int,double (*f)());
void	ratefun(char*,double (*f)());
void	ratefun_0(char*,double (*f)());
void	ratefun_1(char*,int,double (*f)());
void	ratefun_2(char*,int,int,double (*f)());
void	sprobval(char*,double,double);
void	sprobval_0(char*,double,double);
void	sprobval_1(char*,int,double,double);
void	sprobval_2(char*,int,int,double,double);
void	srateval(char*,double,double);
void	srateval_0(char*,double,double);
void	srateval_1(char*,int,double,double);
void	srateval_2(char*,int,int,double,double);
void	sprobdep(char*,double,double,char*);
void	sprobdep_0_0(char*,double,double,char*);
void	sprobdep_1_0(char*,int,double,double,char*);
void	sprobdep_2_0(char*,int,int,double,double,char*);
void	sprobdep_0_1(char*,double,double,char*,int);
void	sprobdep_1_1(char*,int,double,double,char*,int);
void	sprobdep_2_1(char*,int,int,double,double,char*,int);
void	sprobdep_0_2(char*,double,double,char*,int,int);
void	sprobdep_1_2(char*,int,double,double,char*,int,int);
void	sprobdep_2_2(char*,int,int,double,double,char*,int,int);
void	sratedep(char*,double,double,char*);
void	sratedep_0_0(char*,double,double,char*);
void	sratedep_1_0(char*,int,double,double,char*);
void	sratedep_2_0(char*,int,int,double,double,char*);
void	sratedep_0_1(char*,double,double,char*,int);
void	sratedep_1_1(char*,int,double,double,char*,int);
void	sratedep_2_1(char*,int,int,double,double,char*,int);
void	sratedep_0_2(char*,double,double,char*,int,int);
void	sratedep_1_2(char*,int,double,double,char*,int,int);
void	sratedep_2_2(char*,int,int,double,double,char*,int,int);
void	sprobfun(char*,double (*f)(), double (*df)());
void	sprobfun_0(char*,double (*f)(), double (*df)());
void	sprobfun_1(char*,int,double (*f)(), double (*df)());
void	sprobfun_2(char*,int,int,double (*f)(), double (*df)());
void	sratefun(char*,double (*f)(), double (*df)());
void	sratefun_0(char*,double (*f)(), double (*df)());
void	sratefun_1(char*,int,double (*f)(), double (*df)());
void	sratefun_2(char*,int,int,double (*f)(), double (*df)());
void	iarc(char*,char*);
void	iarc_0_0(char*,char*);
void	iarc_0_1(char*,char*,int);
void	iarc_0_2(char*,char*,int,int);
void	iarc_1_0(char*,int,char*);
void	iarc_1_1(char*,int,char*,int);
void	iarc_1_2(char*,int,char*,int,int);
void	iarc_2_0(char*,int,int,char*);
void	iarc_2_1(char*,int,int,char*,int);
void	iarc_2_2(char*,int,int,char*,int,int);
void	oarc(char*,char*);
void	oarc_0_0(char*,char*);
void	oarc_0_1(char*,char*,int);
void	oarc_0_2(char*,char*,int,int);
void	oarc_1_0(char*,int,char*);
void	oarc_1_1(char*,int,char*,int);
void	oarc_1_2(char*,int,char*,int,int);
void	oarc_2_0(char*,int,int,char*);
void	oarc_2_1(char*,int,int,char*,int);
void	oarc_2_2(char*,int,int,char*,int,int);
void	harc(char*,char*);
void	harc_0_0(char*,char*);
void	harc_0_1(char*,char*,int);
void	harc_0_2(char*,char*,int,int);
void	harc_1_0(char*,int,char*);
void	harc_1_1(char*,int,char*,int);
void	harc_1_2(char*,int,char*,int,int);
void	harc_2_0(char*,int,int,char*);
void	harc_2_1(char*,int,int,char*,int);
void	harc_2_2(char*,int,int,char*,int,int);
void	miarc(char*,char*,int);
void	miarc_0_0(char*,char*,int);
void	miarc_0_1(char*,char*,int,int (*m)());
void	miarc_0_2(char*,char*,int,int,int (*m)());
void	miarc_1_0(char*,int,char*,int (*m)());
void	miarc_1_1(char*,int,char*,int,int);
void	miarc_1_2(char*,int,char*,int,int,int (*m)());
void	miarc_2_0(char*,int,int,char*,int);
void	miarc_2_1(char*,int,int,char*,int,int (*m)());
void	miarc_2_2(char*,int,int,char*,int,int,int (*m)());
void	moarc(char*,char*,int);
void	moarc_0_0(char*,char*,int);
void	moarc_0_1(char*,char*,int,int (*m)());
void	moarc_0_2(char*,char*,int,int,int (*m)());
void	moarc_1_0(char*,int,char*,int (*m)());
void	moarc_1_1(char*,int,char*,int,int);
void	moarc_1_2(char*,int,char*,int,int,int (*m)());
void	moarc_2_0(char*,int,int,char*,int);
void	moarc_2_1(char*,int,int,char*,int,int (*m)());
void	moarc_2_2(char*,int,int,char*,int,int,int (*m)());
void	mharc(char*,char*,int);
void	mharc_0_0(char*,char*,int);
void	mharc_0_1(char*,char*,int,int (*m)());
void	mharc_0_2(char*,char*,int,int,int (*m)());
void	mharc_1_0(char*,int,char*,int (*m)());
void	mharc_1_1(char*,int,char*,int,int);
void	mharc_1_2(char*,int,char*,int,int,int (*m)());
void	mharc_2_0(char*,int,int,char*,int);
void	mharc_2_1(char*,int,int,char*,int,int (*m)());
void	mharc_2_2(char*,int,int,char*,int,int,int (*m)());
void	viarc(char*,char*,int);
void	viarc_0_0(char*,char*,int);
void	viarc_0_1(char*,char*,int,int (*m)());
void	viarc_0_2(char*,char*,int,int,int (*m)());
void	viarc_1_0(char*,int,char*,int (*m)());
void	viarc_1_1(char*,int,char*,int,int);
void	viarc_1_2(char*,int,char*,int,int,int (*m)());
void	viarc_2_0(char*,int,int,char*,int);
void	viarc_2_1(char*,int,int,char*,int,int (*m)());
void	viarc_2_2(char*,int,int,char*,int,int,int (*m)());
void	voarc(char*,char*,int);
void	voarc_0_0(char*,char*,int);
void	voarc_0_1(char*,char*,int,int (*m)());
void	voarc_0_2(char*,char*,int,int,int (*m)());
void	voarc_1_0(char*,int,char*,int (*m)());
void	voarc_1_1(char*,int,char*,int,int);
void	voarc_1_2(char*,int,char*,int,int,int (*m)());
void	voarc_2_0(char*,int,int,char*,int);
void	voarc_2_1(char*,int,int,char*,int,int (*m)());
void	voarc_2_2(char*,int,int,char*,int,int,int (*m)());
void	vharc(char*,char*,int);
void	vharc_0_0(char*,char*,int);
void	vharc_0_1(char*,char*,int,int (*m)());
void	vharc_0_2(char*,char*,int,int,int (*m)());
void	vharc_1_0(char*,int,char*,int (*m)());
void	vharc_1_1(char*,int,char*,int,int);
void	vharc_1_2(char*,int,char*,int,int,int (*m)());
void	vharc_2_0(char*,int,int,char*,int);
void	vharc_2_1(char*,int,int,char*,int,int (*m)());
void	vharc_2_2(char*,int,int,char*,int,int,int (*m)());
int	mark(char*);
int	mark_0(char*);
int	mark_1(char*,int);
int	mark_2(char*,int,int);
int	enabled(char*);
int	enabled_0(char*);
int	enabled_1(char*,int);
int	enabled_2(char*,int,int);
double	rate(char*);
double	rate_0(char*);
double	rate_1(char*,int);
double	rate_2(char*,int,int);
void	set_prob0(double (*f)());
void	scale_prob0(double (*f)());
