/*LINTLIBRARY*/

/*************************************************************************

FILE:	cspl_stub.c

*/

# include	<stdio.h>
# include	<ctype.h>
# include	"port.h"
# include	"const.h"
# include	"type.h"

void	iopt(opt,val)
int	opt;		/* the index of the option */
int	val;		/* the value of the option */
{}

void	fopt(opt,val)
int	opt;		/* the index of the option */
double	val;		/* the value of the option */
{}

void	Cplace(name,n1,n2)
char	*name;		/* the name of the place */
int	n1;		/* number on 1st dimension */
int	n2;		/* number on 2nd dimension */
{}

void	Cinit(name,n1,n2,init)
char	*name;		/* the name of the place */
int	n1;		/* index on 1st dimension */
int	n2;		/* index on 2nd dimension */
int	init;		/* initial number of teokens */
{}

void	Ctrans(name,n1,n2)
char	*name;		/* the name of the transition */
int	n1;		/* index on 1st dimension */
int	n2;		/* index on 2nd dimension */
{}

void	Cpriority(name,n1,n2,prio)
char	*name;		/* the name of the transition */
int	n1;		/* index on 1st dimension */
int	n2;		/* index on 2nd dimension */
int	prio;		/* priority of the transition */
{}

void	Cenabling(name,n1,n2,efunc)
char	*name;		/* the name of the transition */
int	n1;		/* index on 1st dimension */
int	n2;		/* index on 2nd dimension */
int	(*efunc)();	/* marking dependent enabling function */
{}

void	Cdistr(type,name,n1,n2,dep,val,place,p1,p2,fun)
int	type;		/* DIS_x */
char	*name;		/* the name of the transition */
int	n1;		/* index on 1st dimension */
int	n2;		/* index on 2nd dimension */
int	dep;		/* DEP_NO, DEP_PL, or DEP_MK */
double	val;		/* value, if DEP_NO or DEP_PL */
char	*place;		/* place, if DEP_PL */
int	p1;		/* index on 1st dimension for the place */
int	p2;		/* index on 2nd dimension for the place */
double	(*fun) ();	/* marking dependent function, if DEP_MK */
{}

/*VARARGS8*/
void	Carc(type,tr,t1,t2,pl,p1,p2,mult,func)
int	type;		/* ARC_x */
char	*tr;		/* name of the transition */
int	t1;		/* index on 1st dimension */
int	t2;		/* index on 2nd dimension */
char	*pl;		/* name of the place */
int	p1;		/* index on 1st dimension */
int	p2;		/* index on 2nd dimension */
int	mult;		/* constant multeplicity of the arc, or VARIABLE */
int	(*func)();	/* marking dependent multiplicity of the arc */
{}

double	input(descr)
char	*descr;
{return(0);}

int	Cmark(pl,n1,n2)
char	*pl;		/* place name */
int	n1;		/* index on 1st dimension */
int	n2;		/* index on 2nd dimension */
{return(0);}

int	Cenabled(tr,n1,n2)
char	*tr;		/* the transition name */
int	n1;		/* index on 1st dimension */
int	n2;		/* index on 2nd dimension */
{return(0);}

double	Crate(tr,n1,n2)
char	*tr;		/* the transition name */
int	n1;		/* index on 1st dimension */
int	n2;		/* index on 2nd dimension */
{return(0);}

double	expected(func)
double	(*func)();	/* the function whose expected value is computed */
{return(0);}

double	accumulated(func)
double	(*func)();	/* the function whose accumulated value is computed */
{return(0);}

void	hold_cond(cond,times)
int	(*cond)();	/* the condition to be tested */
double	times[2];	/* E[time_on] and E[time_off] */
{return;}

void	pr_std_average()
{return;}

void	pr_net_info()
{}

void	pr_rg_info()
{}

void	pr_mc_info()
{}

void	pr_expected(string,func)
char	*string;	/* the string to be printed on output */
double	(*func)();	/* the function whose expected value is computed */
{}

void	pr_accumulated(string,func)
char	*string;	/* the string to be printed on output */
double	(*func)();	/* the function whose accumulated value is computed */
{}

void	Cset_prob0(scale,func)
int	*scale;		/* VAL_YES or VAL_NO */
double	(*func)();	/* the function to define the probabilities */
{}

